# include the sockets module into the namespace:
from socket import * 
#import socket
import sys
import traceback
import time

#### PARAMETERS

# fill up the robotaddr array with the listener addresses
robotaddr_array = []
robotaddr_array.append("[00:13:a2:00:40:3b:0d:d4]!");
#robotaddr_array.append("[00:13:a2:00:40:3b:0d:d9]!");
#robotaddr_array.append("[00:13:a2:00:40:3a:ed:76]!");

################

startport = 12001

#here is where we make a map from zigbee macs to listeners


# connect to the zigbee socket 
# Create the socket, datagram mode, proprietary transport:
# Bind to endpoint 0xe8 (232) for ZB/DigiMesh, but 0x00 for 802.15.4
print 'Attempting to connect to zigbee network'
zigbeesd = socket(AF_ZIGBEE, SOCK_DGRAM, ZBS_PROT_TRANSPORT) 
zigbeesd.bind(("", 0xe8, 0, 0)) 
print 'Connected to zigbee network'

robotsd_array = []
roboterror_array = []
robotdisable_array = []
robotdisablecount_array = []
numrobots = len(robotaddr_array); 

# listen for the cricketds
for i in range(numrobots):
	host = '192.168.1.80'
	print 'Attempting to connect to cricketd', i, ' port ', startport+i
	s = socket(AF_INET, SOCK_STREAM)
	s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1) 
	s.connect((host, startport + i))
	robotsd_array.append(s);
	roboterror_array.append(0);
	robotdisable_array.append(0);
	robotdisablecount_array.append(0);
	print 'connected to cricketd ', i


# here we just loop listening for zigbee messages and passing them to
#   to the correct cricketd

#for j in range(100):
while True:

        active_node_exists = 0 
        for i in range(numrobots):
		if robotdisablecount_array[i] == 0:
			active_node_exists = 1;
			break;

	if active_node_exists == 0:
		print 'No active node exists';
		sys.exit(0);
 
	destcricketd = -1
	# Block until a single frame is received, up to 255 bytes:
	payload, src_addr = zigbeesd.recvfrom(255) 
        
	print 'address: ', src_addr[0]
 
	# compare src_addr to map to determine which cricketd to send it to
	for i in range(numrobots):
	        #print 'checking: ', robotaddr_array[i], ' vs ', src_addr[0]
		#if addresses_equal(robotaddr_array[i], addr[0])
		if robotaddr_array[i] == src_addr[0]:
		#if dumstr is src_addr.address_string
			print 'Got message from cricket: ', i
			destcricketd = i;

	if destcricketd == -1:
		print 'Message received from unknown node: ', src_addr
        elif robotdisable_array[destcricketd] == 1:
		robotdisablecount_array[destcricketd] = robotdisablecount_array[destcricketd] + 1;
		print 'Cricket: ', destcricketd, ' (', src_addr, ') is disabled (', robotdisablecount_array[destcricketd], ' cycles)'
	else:
		try:
			# send the data
			print 'payload: ', payload
			robotsd_array[destcricketd].send(payload)
			roboterror_array[destcricketd] = 0
		except timeout, err:
			print 'socket timeout... retrying';
		except error, err:
			roboterror_array[destcricketd] = roboterror_array[destcricketd] + 1
			print 'socket error... robot ', i, ' numerrors:', roboterror_array[destcricketd]
			if roboterror_array[destcricketd] > 20:
			        print 'Attempting to reconnect to cricketd', i

                                try:
					robotsd_array[destcricketd].close();
        				s = socket(AF_INET, SOCK_STREAM)
        				s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        				s.connect((host, startport + i))

					# Pop out the old socket that no longer works
        				robotsd_array.pop(i)

					# Put in the new socket
        				robotsd_array.insert(i, s)
        				print 'reconnected to cricketd ', i
					roboterror_array[destcricketd] = 0;
                                except error, err:
					print 'Could not connect: ', err
					robotdisable_array[destcricketd] = 1;

			#	zigbeesd.close()
        # loop back up & restart
zigbeesd.close();

