#include <iostream.h>
#include <iomanip.h>

#include <strstream.h>
#include <string.h>
#include <fstream.h>

#include "ioconst.h"
#include "io.h"
#include <iostream.h>

extern "C" {
#include "DE.h"
    extern void exit(int);
    extern void free(void *);
#include "reorder_interf.h"
}
#include "order.H"
extern DExchange my_de;
extern int reorder_debug_flag;
extern buffer_recordPtr the_next_event_buffer;
extern int the_next_event_format_id;
extern DEPort the_next_event_from_client;

extern char *listof_event_names[NUMBER_OF_SENSORS];

void init_structs();
buffer_recordPtr get_init_record();
void headqueue(buffer_recordPtr, int);
void tailqueue(buffer_recordPtr, int);
void check_queue(int);
void process(buffer_recordPtr, int);
void write_record(buffer_recordPtr);
void flush_records();
void Show_Mutexes();
void show_lists();
void show_record(buffer_recordPtr);

int mutex_alloc(mutex_T);
int mutex_init(mutex_T);
int mutex_free(mutex_T);
int mutex_clear(mutex_T);
int condition_free(condition_t);
int condition_clear(condition_t);
int mutex_end_lock(mutex_T, seq_num);
int find_cond_index(condition_t);
int mutex_unlock(mutex_T, seq_num);
int broadcast(condition_t, seq_num, seq_num);
int signal(condition_t, seq_num);
int mutex_begin_lock(mutex_T);
int condition_begin_wait(condition_t, seq_num);
int condition_end_wait(condition_t, seq_num);
int find_mutex(mutex_T);
int find_condition(condition_t);
int alloc_condition(condition_t);
int init_condition(condition_t);
int check_exit(thread_T);
int close_thread(thread_T);
int thread_on_runq(thread_T);
int thread_off_runq(thread_T);
int find_id(thread_T);
int fork_thread(thread_T);
int check_signal(struct COND_NODE *, seq_num);
int HOLD_COUNT;

int DONE, WAIT_FLAG = FALSE;
int counter;

list_node BigList;
buffer_recordPtr ListPtr;

int active[MAX_THREADS];
int empty[MAX_THREADS];
int exited[MAX_THREADS];
int qsize[MAX_THREADS];

list_node List[MAX_THREADS];
int Num_threads;
thread_T thread_num[MAX_THREADS];
int avail_threads[MAX_THREADS];

struct MUTEX_NODE *Mutexes;

struct COND_NODE *Conditions;
struct POST_NODE *temp_post;
struct POST_NODE *prev_post;

void
flush_records()
{
    int index;

    for (index = 0; index < MAX_THREADS; index++) {
	while (List[index].Head != NULL) {
	    write_record(List[index].Head);
	    List[index].Head = List[index].Head->Next;
	}
    }

}

void
check_queue(int index)
{
    buffer_recordPtr new_record;

    if (qsize[index] > 0) {
	new_record = List[index].Head;
	List[index].Head = List[index].Head->Next;
	qsize[index]--;
	process(new_record, index);
    }
}

void
headqueue(buffer_recordPtr new_record, int new_index)
{

    HOLD_COUNT++;
    if (qsize[new_index] == 0) {
	List[new_index].Head = new_record;
	List[new_index].Tail = new_record;
	new_record->Next = NULL;
	qsize[new_index] = 1;
    } else {
	new_record->Next = List[new_index].Head;
	List[new_index].Head = new_record;
	qsize[new_index]++;
    }

}
void
tailqueue(buffer_recordPtr new_record, int new_index)
{

    if (qsize[new_index] == 0) {
	List[new_index].Head = new_record;
	List[new_index].Tail = new_record;
	new_record->Next = NULL;
	qsize[new_index] = 1;
    } else {
	List[new_index].Tail->Next = new_record;
	List[new_index].Tail = new_record;
	new_record->Next = NULL;
	qsize[new_index]++;
    }

}

void
process(buffer_recordPtr new_record, int new_index)
{
    int ok;


    switch (get_type(new_record)) {
    case DM_THREAD_INIT:
	// cout << " DM_THREAD_INIT          " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_THREAD_FORK:
	// cout << " DM_THREAD_FORK          " << endl;
	// cin >> dummy;
	ok = fork_thread(get_child_thread(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write thread_fork" << endl;
	    show_record(new_record);
	    // cin >> dummy;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_THREAD_EXIT:
	// cout << " DM_THREAD_EXIT          " << endl;
	// cin >> dummy;
	ok = close_thread(get_thread(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write thread_exit " << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_THREAD_BEGIN_JOIN:
	// cout << " DM_THREAD_BEGIN_JOIN          " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_THREAD_END_JOIN:
	// cout << " DM_THREAD_END_JOIN          " << endl;
	// cin >> dummy;
	/* if "join_to" thread is still active, don't send join event */
	ok = check_exit(get_join_to(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write thread_end_join" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_THREAD_DETACH:
	// cout << " DM_THREAD_DETACH          " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_THREAD_YIELD:
	// cout << " DM_THREAD_YIELD          " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_THREAD_SET_NAME:
	// cout << " DM_THREAD_SET_NAME          " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_MUTEX_BEGIN_LOCK:
	// cout << " DM_MUTEX_BEGIN_LOCK          " << endl;
	// cin >> dummy;
	ok = mutex_begin_lock(get_mutex(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    // cout << "can't write mutex_begin_lock" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_MUTEX_END_LOCK:
	// cout << " DM_MUTEX_END_LOCK          " << endl;
	ok = mutex_end_lock(get_mutex(new_record), get_seq_num(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write mutex_end_lock" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_MUTEX_UNLOCK:
	// cout << " DM_MUTEX_UNLOCK          " << endl;
	// cin >> dummy;
	ok = mutex_unlock(get_mutex(new_record), get_seq_num(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write mutex_unlock" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_MUTEX_ALLOC:
	// cout << " DM_MUTEX_ALLOC          " << endl;
	// cin >> dummy;
	ok = mutex_alloc(get_mutex(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write mutex_alloc" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_MUTEX_INIT:
	// cout << " DM_MUTEX_INIT           " << endl;
	// cin >> dummy;
	ok = mutex_init(get_mutex(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write mutex_init" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_MUTEX_FREE:
	// cout << " DM_MUTEX_FREE           " << endl;
	// cin >> dummy;
	ok = mutex_free(get_mutex(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    // cout << "can't write mutex_free" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_MUTEX_CLEAR:
	// cout << " DM_MUTEX_CLEAR          " << endl;
	// cin >> dummy;
	ok = mutex_clear(get_mutex(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    // cout << "can't write mutex_clear" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_MUTEX_SET_NAME:
	// cout << " DM_MUTEX_SET_NAME      " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_CONDITION_ALLOC:
	// cout << " DM_CONDITION_ALLOC      " << endl;
	// cin >> dummy;
	ok = alloc_condition(get_condition(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    // cout << "can't write condition_alloc" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_INIT:
	// cout << " DM_CONDITION_INIT       " << endl;
	// cin >> dummy;
	ok = init_condition(get_condition(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    // cout << "can't write condition_init" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_FREE:
	// cout << " DM_CONDITION_FREE       " << endl;
	// cin >> dummy;
	ok = condition_free(get_condition(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    // cout << "can't write condition_free" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_CLEAR:
	// cout << " DM_CONDITION_CLEAR      " << endl;
	// cin >> dummy;
	ok = condition_clear(get_condition(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    // cout << "can't write condition_clear" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_BEGIN_WAIT:
	// cout << " DM_CONDITION_BEGIN_WAIT       " << endl;
	// cin >> dummy;
	ok = condition_begin_wait(get_condition(new_record),
				  get_seq_num(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write condition_begin_wait" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_END_WAIT:
	// cout << " DM_CONDITION_END_WAIT" << endl;
	// cin >> dummy;
	ok = condition_end_wait(get_condition(new_record),
				get_seq_num(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write condition_end_wait" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_BROADCAST:
	// cout << " DM_CONDITION_BROADCAST  " << endl;
	// cin >> dummy;
	ok = broadcast(get_condition(new_record),
		       get_begin_seq_num(new_record),
		       get_end_seq_num(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write condition_broadcast" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_SIGNAL:
	// cout << " DM_CONDITION_SIGNAL     " << endl;
	// cin >> dummy;
	ok = signal(get_condition(new_record),
		    get_seq_num(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write condition_signal" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_CONDITION_SET_NAME:
	// cout << " DM_CONDITION_SET_NAME " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_THREAD_OFF_RUNQ:
	// cout << " DM_THREAD_OFF_RUNQ " << endl;
	// cin >> dummy;
	ok = thread_off_runq(get_thread(new_record));
	if (ok == TRUE) {
	    write_record(new_record);
	} else {
	    cout << "can't write thread_off_runq" << endl;
	    headqueue(new_record, new_index);
	}
	break;
    case DM_PROCESSOR_BEGIN_IDLE:
	// cout << " DM_PROCESSOR_BEGIN_IDLE" << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_PROCESSOR_END_IDLE:
	// cout << " DM_PROCESSOR_END_IDLE " << endl;
	// cin >> dummy;
	write_record(new_record);
	break;
    case DM_PROGRAM_EXIT:
	// cout << " DM_PROGRAM_EXIT " << endl;
	// cin >> dummy;
	write_record(new_record);
	DONE = TRUE;
	break;
    case DM_MONITOR_EXIT:
	// cout << " DM_MONITOR_EXIT " << endl;
	// cin >> dummy;
	DONE = TRUE;
	write_record(new_record);
	break;
    };				/* end switch */
}


void
show_lists()
{

    int index;

    for (index = 0; index < MAX_THREADS; index++) {
	if (thread_num[index] != NULL) {
	    cout << "tname = " << thread_num[index]
		<< ", index = " << index
		<< endl;
	    ListPtr = List[index].Head;
	    while (ListPtr != NULL) {
		show_record(ListPtr);
		ListPtr = ListPtr->Next;
	    }
	    // cin >> dummy;
	}
    }


}

static void
print_thread(buffer_recordPtr rec)
{
    thread_T thread = get_thread(rec);
    for (int i = 0; i < thread->size; i+=sizeof(int)) {
	cout << *(int*)(&thread->data[i]);
    }
    cout << " ";
    free(thread);
}

static void
print_join_to(buffer_recordPtr rec)
{
    thread_T thread = get_join_to(rec);
    for (int i = 0; i < thread->size; i+=sizeof(int)) {
	cout << *(int*)(&thread->data[i]);
    }
    cout << " ";
    free(thread);
}

static void
print_child_thread(buffer_recordPtr rec)
{
    thread_T thread = get_child_thread(rec);
    for (int i = 0; i < thread->size; i+=sizeof(int)) {
	cout << "%08x",*(int*)(&thread->data[i]);
    }
    cout << " ";
    free(thread);
}

static void
print_condition(buffer_recordPtr rec)
{
    condition_t condition = get_condition(rec);
    for (int i = 0; i < condition->size; i+=sizeof(int)) {
	cout << *(int*)(&condition->data[i]);
    }
    cout << " ";
    free(condition);
}

static void
print_mutex(buffer_recordPtr rec)
{
    mutex_T mutex = get_mutex(rec);
    for (int i = 0; i < mutex->size; i+=sizeof(int)) {
	cout << *(int*)(&mutex->data[i]);
    }
    cout << " ";
    free(mutex);
}

void
show_record(buffer_recordPtr new_record)
{
    switch (get_type(new_record)) {
    case DM_THREAD_INIT:
	cout << "THREAD_INIT: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_THREAD_FORK:
	cout << "THREAD_FORK: ";
	print_thread(new_record);
	print_child_thread(new_record);
	cout << get_seq_num(new_record) << " ";
	cout << endl;
	break;
    case DM_THREAD_EXIT:
	cout << "THREAD_EXIT: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_THREAD_BEGIN_JOIN:
	cout << "THREAD_BEGIN_JOIN: ";
	print_thread(new_record);
	print_join_to(new_record);
	cout << endl;
	break;
    case DM_THREAD_END_JOIN:
	cout << "THREAD_END_JOIN: ";
	print_thread(new_record);
	print_join_to(new_record);
	cout << endl;
	break;
    case DM_THREAD_DETACH:
	cout << "THREAD_DETACH: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_THREAD_YIELD:
	cout << "THREAD_YIELD: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_THREAD_SET_NAME:
	cout << "THREAD_SET_NAME: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_MUTEX_BEGIN_LOCK:
	cout << "MUTEX_BEGIN_LOCK: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << get_seq_num(new_record) << " ";
	cout << endl;
	break;
    case DM_MUTEX_END_LOCK:
	cout << "MUTEX_END_LOCK: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << get_seq_num(new_record) << " ";
	cout << endl;
	break;
    case DM_MUTEX_UNLOCK:
	cout << "MUTEX_UNLOCK: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << get_seq_num(new_record) << " ";
	cout << endl;
	break;
    case DM_MUTEX_ALLOC:
	cout << "MUTEX_ALLOC: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << endl;
	break;
    case DM_MUTEX_INIT:
	cout << "MUTEX_INIT: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << endl;
	break;
    case DM_MUTEX_FREE:
	cout << "MUTEX_FREE: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << endl;
	break;
    case DM_MUTEX_CLEAR:
	cout << "MUTEX_CLEAR: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << endl;
	break;
    case DM_MUTEX_SET_NAME:
	cout << "DM_MUTEX_SET_NAME: ";
	print_thread(new_record);
	print_mutex(new_record);
	cout << endl;
	break;
    case DM_CONDITION_ALLOC:
	cout << "CONDITION_ALLOC: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << endl;
	break;
    case DM_CONDITION_INIT:
	cout << "CONDITION_INIT: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << endl;
	break;
    case DM_CONDITION_FREE:
	cout << "CONDITION_FREE: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << endl;
	break;
    case DM_CONDITION_CLEAR:
	cout << "CONDITION_CLEAR: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << endl;
	break;
    case DM_CONDITION_BEGIN_WAIT:
	cout << "CONDITION_BEGIN_WAIT: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << get_seq_num(new_record) << " ";
	print_mutex(new_record);
	cout << endl;
	break;
    case DM_CONDITION_END_WAIT:
	cout << "CONDITION_END_WAIT: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << get_seq_num(new_record) << " ";
	print_mutex(new_record);
	cout << endl;
	break;
    case DM_CONDITION_BROADCAST:
	cout << "CONDITION_BROADCAST: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << get_begin_seq_num(new_record) << " ";
	cout << get_end_seq_num(new_record) << " ";
	cout << endl;
	break;
    case DM_CONDITION_SIGNAL:
	cout << "CONDITION_SIGNAL: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << get_seq_num(new_record) << " ";
	cout << endl;
	break;
    case DM_CONDITION_SET_NAME:
	cout << "CONDITION_SET_NAME: ";
	print_thread(new_record);
	print_condition(new_record);
	cout << endl;
	break;
    case DM_THREAD_OFF_RUNQ:
	cout << "THREAD_OFF_RUNQ: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_PROCESSOR_BEGIN_IDLE:
	cout << "PROCESSOR_BEGIN_IDLE: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_PROCESSOR_END_IDLE:
	cout << "PROCESSOR_END_IDLE: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_PROGRAM_EXIT:
	cout << "PROGRAM_EXIT: ";
	print_thread(new_record);
	cout << endl;
	break;
    case DM_MONITOR_EXIT:
	cout << "MONITOR_EXIT: ";
	print_thread(new_record);
	cout << endl;
	break;

    }				// end switch 


}

void
write_record(buffer_recordPtr record)
{
    cout << "                         ";
    show_record(record);

    DErelease_data(record->rec);
    free(record);
}


void
init_structs()
{
    int i;

    for (i = 0; i < MAX_THREADS; i++) {
	thread_num[i] = (thread_T) 0;
	avail_threads[i] = TRUE;
	active[i] = FALSE;
	empty[i] = TRUE;
	exited[i] = FALSE;

	qsize[i] = 0;
	List[i].Head = NULL;
	List[i].Tail = NULL;
    }

    Conditions = NULL;
}

int
mutex_alloc(mutex_T mutex)
{
    struct MUTEX_NODE *temp_mutex;

    if (find_mutex(mutex) == FALSE) {
	// allocate a new mutex node
	temp_mutex = new MUTEX_NODE;
	temp_mutex->mutex = (mutex_T) mutex;
	temp_mutex->Max_seq_end_lock = 0;
	temp_mutex->Next = NULL;

	// start a list
	if (Mutexes == NULL) {
	    Mutexes = temp_mutex;
	} else {
	    // or add it to the front of the list
	    temp_mutex->Next = Mutexes;
	    Mutexes = temp_mutex;
	}
	return (TRUE);
    } else {
	return (FALSE);
    }



}

int
mutex_init(mutex_T mutex)
{
    struct MUTEX_NODE *temp_mutex;

    if (find_mutex(mutex) == FALSE) {
	// allocate a new mutex node
	temp_mutex = new MUTEX_NODE;
	temp_mutex->mutex = (mutex_T) mutex;
	temp_mutex->Max_seq_end_lock = 0;
	temp_mutex->Next = NULL;

	// start a list
	if (Mutexes == NULL) {
	    Mutexes = temp_mutex;
	} else {
	// or add it to the front of the list
	    temp_mutex->Next = Mutexes;
	    Mutexes = temp_mutex;
	}
    }
    return (TRUE);
}

int
mutex_free(mutex_T)
{
    return (TRUE);
}

int
mutex_clear(mutex_T)
{
    return (TRUE);
}


int
condition_free(condition_t)
{
    return (TRUE);
}

int
condition_clear(condition_t)
{
    return (TRUE);
}

int
mutex_end_lock(mutex_T mutex, seq_num seq_num)
{
    int FOUND = FALSE;
    struct MUTEX_NODE *temp_mutex;

    // find the right node for the mutex
    temp_mutex = Mutexes;
    while ((temp_mutex != NULL) && (FOUND == FALSE)) {
	if (equal(temp_mutex->mutex, mutex)) {
	    FOUND = TRUE;
	} else {
	    temp_mutex = temp_mutex->Next;
	}
    }

    if (FOUND == TRUE) {
	// the mutex already exists
	if (seq_num == temp_mutex->Max_seq_end_lock + 1) {
	    // if the seq_num is okay
	    temp_mutex->Max_seq_end_lock = temp_mutex->Max_seq_end_lock + 1;
	    return (TRUE);
	} else {
	    // put the record back in the buffer
	    return (FALSE);
	}

    } else {
	// the mutex has not been allocated
	cout << "mutex " << mutex << "not yet allocated. " << endl;
	return (FALSE);
    }
}

int
find_cond_index(condition_t)
{
    return (FALSE);
}

int
mutex_unlock(mutex_T mutex, seq_num seq_num)
{
    struct MUTEX_NODE *temp_mutex;
    int FOUND = FALSE;


    // find the right node for the mutex
    temp_mutex = Mutexes;
    while ((temp_mutex != NULL) && (FOUND == FALSE)) {
	if (equal(temp_mutex->mutex, mutex)) {
	    FOUND = TRUE;
	} else {
	    temp_mutex = temp_mutex->Next;
	}
    }

    if (FOUND == TRUE) {
	// the mutex already exists
	if (seq_num <= temp_mutex->Max_seq_end_lock) {
	    // if the seq_num is okay
	    return (TRUE);
	} else {
	    // put the record back in the buffer
	    return (FALSE);
	}
    } else {
	// the mutex has not been allocated
	return (FALSE);
    }
}

int
broadcast(condition_t condition_num,
	  seq_num start_seq_num,
	  seq_num end_seq_num)
{
    int FOUND = FALSE;
    long i;
    struct COND_NODE *temp_cond;

    // find the node for that condition

    temp_cond = Conditions;
    while ((temp_cond != NULL) && (FOUND == FALSE)) {
	if (equal(temp_cond->cond_num, condition_num)) {
	    FOUND = TRUE;
	} else {
	    temp_cond = temp_cond->Next;
	}
    }

    if (FOUND == FALSE) {
	cout << "error - unallocated condition broadcast " << endl;
	return (FALSE);
    } else {			// (the condition variable exists)
	// check that the highest sequence number has a begin_wait

	if (temp_cond->Max_sequence_waiting < end_seq_num) {
	    // cout << "not all begin waits posted " << endl;
	    return (FALSE);
	} else {
	    for (i = start_seq_num + 1; i <= end_seq_num; i++) {
		signal(condition_num, i);
	    }
	}
	return (TRUE);
    }
}

int
signal(condition_t condition_num, seq_num sequence_num)
{
    int FOUND = FALSE;
    struct COND_NODE *temp_cond;

    // first, find that condition variable
    temp_cond = Conditions;
    while ((temp_cond != NULL) && (FOUND == FALSE)) {
	if (equal(temp_cond->cond_num, condition_num)) {
	    FOUND = TRUE;
	    // cout << "found condition variable " << temp_cond->cond_num
	    // << "on the list." << endl;
	} else {
	    temp_cond = temp_cond->Next;
	}
    }

    if (FOUND == FALSE) {
	cout << "error - unallocated condition signalled " << endl;
	return (FALSE);
    } else {			// (the condition variable exists)
	// has the begin_wait happened?

	if (sequence_num > temp_cond->Max_sequence_waiting) {
	    cout << "no begin wait yet! " << endl;
	    return (FALSE);
	} else {
	    // add it to the list of signalled seq nums 
	    temp_post = new POST_NODE;
	    temp_post->Seq_Num = sequence_num;
	    if (temp_cond->Signalled == NULL) {
		temp_cond->Signalled = temp_post;
		temp_post->Next = NULL;
	    } else {
		temp_post->Next = temp_cond->Signalled;
		temp_cond->Signalled = temp_post;
	    }
	}
	return (TRUE);
    }				// end else (the condition variable
    // exists)

}

void
Show_Mutexes()
{
    int FOUND = FALSE;
    struct MUTEX_NODE *temp_mutex;

    temp_mutex = Mutexes;
    while ((temp_mutex != NULL) && (FOUND == FALSE)) {
	cout << "Mutex: " << temp_mutex->mutex << " "
	    << "Max_end: " << temp_mutex->Max_seq_end_lock << " "
	    << endl;
	temp_mutex = temp_mutex->Next;
    }
    // cin >> dummy;

}

int
mutex_begin_lock(mutex_T mutex)
{
    int FOUND = FALSE;
    struct MUTEX_NODE *temp_mutex;

    // find the right node for the mutex

    temp_mutex = Mutexes;
    while ((temp_mutex != NULL) && (FOUND == FALSE)) {
	if (equal(temp_mutex->mutex, mutex)) {
	    FOUND = TRUE;
	} else {
	    temp_mutex = temp_mutex->Next;
	}
    }

    if (FOUND == TRUE) {
	// the mutex already exists
	return (TRUE);
    } else {
	// the mutex has not been allocated
	return (FALSE);
    }

}


int
condition_begin_wait(condition_t new_cond_num, seq_num new_seq_num)
{
    int FOUND;
    struct COND_NODE *temp_cond;


    FOUND = FALSE;
    temp_cond = Conditions;
    while ((temp_cond != NULL) && (FOUND == FALSE)) {
	if (equal(temp_cond->cond_num, new_cond_num)) {
	    FOUND = TRUE;
	} else {
	    temp_cond = temp_cond->Next;
	}
    }				// end while

    if (FOUND != TRUE)
	return (FALSE);


    if (new_seq_num != temp_cond->Max_sequence_waiting + 1)
	return (FALSE);

    temp_cond->Max_sequence_waiting++;

    return (TRUE);
}

int
condition_end_wait(condition_t new_cond_num, seq_num new_seq_num)
{
    int FOUND;
    int ok;
    struct COND_NODE *temp_cond;


    FOUND = FALSE;
    temp_cond = Conditions;
    while ((temp_cond != NULL) && (FOUND == FALSE)) {
	if (equal(temp_cond->cond_num, new_cond_num)) {
	    FOUND = TRUE;
	} else {
	    temp_cond = temp_cond->Next;
	}
    }				// end while

    if (FOUND != TRUE) {
	cout << " condition not found " << endl;
	return (FALSE);
    }
    /* has this sequence number been signalled? */

    ok = check_signal(temp_cond, new_seq_num);
    if (ok) {
	return (TRUE);
    } else {
	return (FALSE);
    }

}
int
check_signal(struct COND_NODE *temp_cond, seq_num new_seq_num)
{
    int POSTED;
    struct POST_NODE *temp_post;


    POSTED = FALSE;
    temp_post = temp_cond->Signalled;
    while ((temp_post != NULL) && (POSTED == FALSE)) {
	if (temp_post->Seq_Num == new_seq_num) {
	    // yes, it was posted
	    POSTED = TRUE;
	}			// end if temp_post->Seq_Num

	temp_post = temp_post->Next;
    }				// end while

    return (POSTED);

}


int
find_mutex(mutex_T mutex)
{

    int FOUND = FALSE;
    struct MUTEX_NODE *temp_mutex;

    temp_mutex = Mutexes;
    while ((temp_mutex != NULL) && (FOUND == FALSE)) {
	if (equal(temp_mutex->mutex, mutex)) {
	    FOUND = TRUE;
	} else {
	    temp_mutex = temp_mutex->Next;
	}
    }

    return (FOUND);
}

int
find_condition(condition_t cond_num)
{

    int FOUND = FALSE;
    struct COND_NODE *temp_cond;

    temp_cond = Conditions;
    while ((temp_cond != NULL) && (FOUND == FALSE)) {
	if (equal(temp_cond->cond_num, cond_num)) {
	    FOUND = TRUE;
	} else {
	    temp_cond = temp_cond->Next;
	}
    }

    return (FOUND);
}

int
init_condition(condition_t new_cond_num)
{

    struct COND_NODE *temp_cond;


    if (find_condition(new_cond_num) == FALSE) {
	// allocate a new condition node
	// temp_cond = (COND_NODE_t *) malloc (sizeof(COND_NODE_t));
	temp_cond = new COND_NODE;
	temp_cond->cond_num = (condition_t) new_cond_num;
	temp_cond->Max_sequence_waiting = 0;
	temp_cond->Signalled = NULL;
	temp_cond->Next = NULL;

	// start a list
	if (Conditions == NULL) {
	    Conditions = temp_cond;
	} else {
	    // or add it to the front of the list
	    temp_cond->Next = Conditions;
	    Conditions = temp_cond;
	}
	return (TRUE);
    } else {
	return (FALSE);
    }

}

int
alloc_condition(condition_t new_cond_num)
{

    struct COND_NODE *temp_cond;

    if (find_condition(new_cond_num) == FALSE) {
	// allocate a new condition node
	// temp_cond = (COND_NODE_t *) malloc (sizeof(COND_NODE_t));
	temp_cond = new COND_NODE;
	temp_cond->cond_num = (condition_t) new_cond_num;
	temp_cond->Max_sequence_waiting = 0;
	temp_cond->Signalled = NULL;
	temp_cond->Next = NULL;

	// start a list
	if (Conditions == NULL) {
	    Conditions = temp_cond;
	} else {
	    // or add it to the front of the list
	    temp_cond->Next = Conditions;
	    Conditions = temp_cond;
	}
	return (TRUE);
    } else {
	return (FALSE);
    }


}

int
check_exit(thread_T join_to)
{
    int i;
    int FOUND = FALSE;


    i = 0;
    while ((!FOUND) && (i < MAX_THREADS)) {
	if (equal(thread_num[i], join_to)) {
	    FOUND = TRUE;
	    if (exited[i] == TRUE) {
		return (TRUE);
	    } else {
		return (FALSE);
	    }
	} else {
	    i++;
	}
    }
    // if the thread does not exist, return FALSE
    return (FALSE);


}

int
thread_on_runq(thread_T)
{
    return (TRUE);
}

int
thread_off_runq(thread_T)
{
    return (TRUE);
}

int
close_thread(thread_T tname)
{
    int i;
    int FOUND = FALSE;

    // If the thread exists, close it, and return TRUE 
    i = 0;
    while ((!FOUND) && (i < MAX_THREADS)) {
	if (thread_num[i] && equal(thread_num[i], tname)) {
	    FOUND = TRUE;
	    active[i] = FALSE;
	    exited[i] = TRUE;
	} else {
	    i++;
	}
    }
    // if the thread does not exist, return FALSE
    return (FOUND);
}

int
fork_thread(thread_T tname)
{
    int index;

    index = find_id(tname);
    if (index > -1) {
	active[index] = TRUE;
	return (TRUE);
    } else {
	return (FALSE);
    }
}

int
find_id(thread_T tname)
{

    int i;
    int FOUND = FALSE;
    int FREE = FALSE;

    i = 0;
    while ((!FOUND) && (i < MAX_THREADS)) {
	if (thread_num[i] && equal(thread_num[i], tname)) {
	    FOUND = TRUE;
	} else {
	    i++;
	}
    }
    if (FOUND) {
	return (i);
    } else {
	i = 0;
	while ((!FREE) && (i < MAX_THREADS)) {
	    if (avail_threads[i] == TRUE) {
		avail_threads[i] = FALSE;
		thread_num[i] = tname;
		FREE = TRUE;
	    } else {
		i++;
	    }
	}			/* end while */
	if (FREE) {
	    return (i);
	} else {
	    return (-1);
	}
    }				/* end else */
}


static
const char *usage = 
"Usage: reorder takes the following arguments:\n\
  Input specification:\n\
\t    default: open DataExchange group and wait for input connection\n\
\t-isock_in <host> <port> -- also input from internet socket\n\
\t-rfile <filename> -- also input from PBIO file\n\
\t-no-dynamic -- do not open DataExchange group\n\
  Output specification:\n\
\t    default: output to via DataExchange connections\n\
\t-wfile <filename> -- also output to PBIO file\n\
  Miscellaneous\n\
\t-verbose -- prints name of established DE group\n\
\t-debug -- turns on detailed printf-style debugging output\n\
\t-app_name <name>  -- use <name> as the comm group application\n\
\t                     name to register (default \"reorder\")\n\
\t-comm_type <name>  -- use <name> as the comm group type\n\
\t                      to register (default \"reorder\")\n";

extern "C" {
    void reorder_process_record() {
	buffer_recordPtr new_record;
	 new_record = the_next_event_buffer;
	int new_index, index;
	thread_T new_thread = get_thread(new_record);

	if (DESavedRec_format_id(new_record->rec) == format_ids[DM_THREAD_INIT]) {
	    int index = find_id(new_thread);
	    active[index] = TRUE;
	}
	    
	new_index = find_id(new_thread);

	if (get_type(new_record) == DM_MONITOR_EXIT)
	     active[new_index] = TRUE;

	 show_record(new_record);
	if (active[new_index] == FALSE) {
	    cout << "Holding because thread " << new_thread << " is inactive\n";
	    tailqueue(new_record, new_index);
	} else {
	    if (qsize[new_index] == 0) {
		process(new_record, new_index);
	    } else {
		tailqueue(new_record, new_index);
	    }
	}
	for (index = 0; index < MAX_THREADS; index++) {
	    if (active[index] == TRUE)
		check_queue(index);
	}
	if (DONE) {
	    cout << "records were held back " << HOLD_COUNT << "times" << endl;
	    exit(1);
	}
    }
}

extern "C" int dynamic_input;

main(int argc, char *argv[])
{
    DONE = FALSE;

    if (CMonInterfInit(&argc, argv) < 0) {
	cout << usage;
	exit(1);
    }
    init_structs();

    while (!DONE) {
      if (dynamic_input) {
	DExchange_poll_and_handle(my_de, True);
      } else {
	DExchange_poll_and_handle(my_de, False);
      }	
    }
}
