#ifndef BLOB_TRACKER_H
#define BLOB_TRACKER_H

#include <vector>

struct BlobType {
  
  int BlobID;                  // Object Type
  int MinSize;                 // Minimum size blob will return a object reading

  int MinR;          //   Color ranges used for blob detection
  int MaxR;
  int MinB;
  int MaxB;
  int MinG;
  int MaxG;

  int OneMArea;               //  Blob sizes at various distances for location estimation
  int TwoMArea;
  int ThreeMArea;

  
};


struct BlobBox {
  int BlobType;

  int MinX;        // Blob bounding box coordinates
  int MaxX;
  int MinY;
  int MaxY;

  int Area;
  
  float MidX;
  float MidY;

  float XPos;      // Ego-centric X position of the blob
  float YPos;      // Ego-centric Y position of the blob
};


std::vector<BlobType> BlobData;
std::vector<BlobBox> CurBlobs;

#endif
