/**********************************************************************
 **                                                                  **
 **                  PoseCalculatorFilterInterface.h                 **
 **                                                                  **
 **                                                                  **
 **  Written by:  Yoichiro Endo                                      **
 **                                                                  **
 **  Copyright 2004, Georgia Tech Research Corporation               **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  **
 **********************************************************************/

/* $Id: PCModuleFilterInterface.h,v 1.1.1.1 2008-07-14 16:44:19 endo Exp $ */

#ifndef POSECALC_MODULE_FILTER_INTERFACE_H
#define POSECALC_MODULE_FILTER_INTERFACE_H

#include "PoseCalculatorTypes.h"

class PoseCalcModuleFilterInterface {

public:
    virtual void filter(PoseCalcPoseInfo_t &poseInfo) = 0;
};

#endif

/**********************************************************************
# $Log: PCModuleFilterInterface.h,v $
# Revision 1.1.1.1  2008-07-14 16:44:19  endo
# MAST Project (based on MissionLab-MINOS-20071018.tar.gz)
#
# Revision 1.1.1.1  2006/07/20 17:17:48  endo
# MINOS Project (based on MissionLab-7.0.20060712.tar.gz)
#
# Revision 1.1.1.1  2006/07/12 13:37:57  endo
# MissionLab 7.0
#
# Revision 1.1  2006/06/05 21:35:53  endo
# PoseCalculator from MARA 2020 migrated
#
# Revision 1.1  2004/09/10 19:59:17  endo
# New PoseCalc integrated.
#
#**********************************************************************/
