/**********************************************************************
 **                                                                  **
 **                    PCSituationalContextSensory.h                 **
 **                                                                  **
 **                                                                  **
 **  Written by:  Yoichiro Endo                                      **
 **                                                                  **
 **  Copyright 2004, Georgia Tech Research Corporation               **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  **
 **********************************************************************/

/* $Id: PCSituationalContextSensory.h,v 1.1.1.1 2008-07-14 16:44:19 endo Exp $ */

#ifndef POSECALC_SITUATIONAL_CONTEXT_SENSORY_H
#define POSECALC_SITUATIONAL_CONTEXT_SENSORY_H

#include "PCSituationalContextInterface.h"
#include "PoseCalculatorTypes.h"

class PoseCalcSituationalContextSensory : 
    public PoseCalcSituationalContextInterface {

protected:
    double getSituationalValue_(int sensorType, int poseType);

public:
    PoseCalcSituationalContextSensory(void);
    void applySituation(PoseCalcGenericData_t &data);

    virtual ~PoseCalcSituationalContextSensory(void);
};

#endif

/**********************************************************************
# $Log: PCSituationalContextSensory.h,v $
# Revision 1.1.1.1  2008-07-14 16:44:19  endo
# MAST Project (based on MissionLab-MINOS-20071018.tar.gz)
#
# Revision 1.1.1.1  2006/07/20 17:17:48  endo
# MINOS Project (based on MissionLab-7.0.20060712.tar.gz)
#
# Revision 1.1.1.1  2006/07/12 13:37:57  endo
# MissionLab 7.0
#
# Revision 1.1  2006/06/05 21:35:53  endo
# PoseCalculator from MARA 2020 migrated
#
# Revision 1.1  2004/09/10 19:59:19  endo
# New PoseCalc integrated.
#
#**********************************************************************/
