#ifndef CRICKET_H
#define CRICKET_H

#include <pthread.h>
#include <semaphore.h>
#include <string>
#include "robot_config.h"
#include "sensors.h"
#include "module.h"
#include "hserver_ipt.h"

using std::string;

/*
enum EnGpsInfoType
{
    EnGpsInfoType_LAT = 0,
    EnGpsInfoType_LON,
    EnGpsInfoType_HEIGHT,
    EnGpsInfoType_DIRECTION,
    EnGpsInfoType_HORIZONTAL_SPEED,
    EnGpsInfoType_VERTICAL_SPEED,
    EnGpsInfoType_NUM_SATS,
    EnGpsInfoType_COUNT     // this must be declared last
};
*/

class Cricket: public Module
{
protected:
    Sensor* sensorCricket;
    RobotPartCricket* partCricket;
    IPHandlerCallback* callback;
    pthread_t reader;
    pthread_t cricket_reader;
    pthread_mutex_t mutexStatsLock; 

    float xyz[ 3 ];
    double LastUpdateTime;


    unsigned int UpdateCricketTime;
    bool ConnectedToPositionServer;
    int PositionServerSD;
    char *IP;
    char *Port;

    int RobotId;

    int poseCalcID_;
    void addSensors();
    void updateStatusBar_(void);

    static const int WATCHDOG_CHECK_INTERVAL_SEC_;

    void ConnectToPositionServer(void);

    double calculate_yaw(HSPose_t &pose, bool &gotValidYaw);

public:
    void reader_thread();
    void cricket_thread();
    void savePoseCalcID(int id);
    Cricket( Cricket** a, const string& strPortString, int id);
    ~Cricket();
};

inline void Cricket::savePoseCalcID(int id)
{
    poseCalcID_ = id;
}

extern Cricket* cricket;

#endif
