#include <stdio.h>
#include <unistd.h>
#include "NetComm.h"
#include "trilateration.h"

int main(int argc, char *argv[]) {
  char result[10000];
  bool gotvalue = false;
  int dbval;
  FILE *in = NULL;
  beaconrecord br;
  beaconposition bp;
  char *tresult = NULL;
  double timestamp;

  // PARAMETERS (fitting function)
  double sonarscale =  1.076902;  //1  if previously corrected in PositionServer*)
  double sonaroffset = -4.4617;  // 0 if prev. corrected in PositionServer*)

  Trilateration *tri = new Trilateration();

  NetComm *comm = NULL;
  if (argc <= 1) {
    comm = new NetComm();
    comm->setHost("192.168.1.80");
    comm->setPort(3001);
    comm->init();
    comm->write_("register\n\r");
  } else {
    in = fopen(argv[1], "r");
    printf("Opening %s\n", argv[1]);
    if (in == NULL) {
      exit(EXIT_FAILURE);
    } 
  }

  while (1) {
    if (argc <= 1)
      comm->read_(result);
    else
      fgets(result, 999, in);

    printf("received %s\n", result);

           gotvalue = true;
        if ( (tresult = strstr(result, "DB=")) != NULL) {
                sscanf(tresult, "DB=%d", &dbval);

                br.db = (double) dbval;

                // Apply fitting function
                br.db = (br.db * sonarscale) + sonaroffset;

        } else {
                gotvalue = false;
        }

        if ( (tresult = strstr(result, "SP=")) != NULL) {
                sscanf(tresult, "SP=BEACON-%d", &br.beaconid);
        } else {
                gotvalue = false;
        }

        if ( (tresult = strstr(result, "TS=")) != NULL) {
                sscanf(tresult, "TS=%lf", &br.timestamp);
                timestamp = br.timestamp;
        } else {
                gotvalue = false;
        }

        if (gotvalue) {
                if (tri->addData(br) == false) {
                        fprintf(stderr, "%.0lf: Could not add beacon reading\n", timestamp);
                } else {
                        //printf("%.0lf: Added %d,%lf\n", timestamp, br.beaconid, br.db);
                }

                if (tri->getPosition(bp) == true) {
                        printf("%.0lf: Received Position (%lf,%lf,%lf)\n", timestamp, bp.x, bp.y, bp.z);
                } else {
                        printf("%.0lf: No position\n", timestamp);
                }

        }
 
    usleep(10000);
  }
}
