/**********************************************************************
 **                                                                  **
 **                       LabelToIdConversions.c                     **
 **                                                                  **
 **                                                                  **
 **  Written by:  Brian Lee                                          **
 **                                                                  **
 **  Copyright 2002 - 2008, Georgia Tech Research Corporation        **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  **
 **********************************************************************/

/* $Id: LabelToIdConversions.c,v 1.5 2010-05-03 22:12:57 zkira Exp $ */

#include "LabelToIdConversions.h"

const SuLabelIdPair* aasuVALUE_TYPE_CONVERSIONS[NUM_LABEL_ID_PAIRS] = 
{
    asuCAMERA_LABEL_CONVERSIONS,
    asuLASER_LABEL_CONVERSIONS,
    asuROBOT_LABEL_CONVERSIONS,
    asuGAZEBO_LABEL_CONVERSIONS,
    asuUSARSIM_LABEL_CONVERSIONS,
    asuROVIO_LABEL_CONVERSIONS,
    asuSKYBOTIX_LABEL_CONVERSIONS,
    asuOPENCV_LABEL_CONVERSIONS,
    asuCOGNACHROME_LABEL_CONVERSIONS,
    asuNOMAD_LABEL_CONVERSIONS,
    asuPIONEER_LABEL_CONVERSIONS,
    asuPIONEER2_LABEL_CONVERSIONS,
    asuAMIGOBOT_LABEL_CONVERSIONS,
    asuFRAMEGRABBER_LABEL_CONVERSIONS,
    asuGPS_LABEL_CONVERSIONS,
    asuCRICKET_LABEL_CONVERSIONS,
    asuJBOX_LABEL_CONVERSIONS,
    asuCOMPASS_LABEL_CONVERSIONS,
    asuGYRO_LABEL_CONVERSIONS,
    asuPOSECALC_LABEL_CONVERSIONS
};

/**********************************************************************
# $Log: LabelToIdConversions.c,v $
# Revision 1.5  2010-05-03 22:12:57  zkira
# Addition of rovio & cricket
#
# Revision 1.3  2009/03/02 18:47:08  zkira
# Added ability to change low level robot parameters (e.g. max speed) in the .hserverrc file.
# Added Rovio
#
# Revision 1.2  2008/07/15 22:34:02  endo
# OpenCV, Gazebo and USARSim added.
#
# Revision 1.4  2008/01/09 22:54:03  endo
# USARSimRobot added.
#
# Revision 1.3  2006/12/01 21:14:54  endo
# Regular backup.
#
# Revision 1.2  2006/08/08 21:33:49  endo
# GazeboLaser added.
#
# Revision 1.1.1.1  2006/07/21 17:42:17  endo
# HServer for Gazebo (based on MissionLab-7.0.20060712.tar.gz)
#
# Revision 1.1.1.1  2006/07/12 13:37:57  endo
# MissionLab 7.0
#
# Revision 1.2  2006/06/05 21:35:54  endo
# PoseCalculator from MARA 2020 migrated
#
# Revision 1.1  2006/05/15 06:01:03  endo
# gcc-3.4 upgrade
#
#**********************************************************************/
