
#pragma once
#include <pthread.h>
#include <curl/curl.h>
#include <string>


#ifndef NO_OPENCV
#include <highgui.h>
#endif

#include "hserver.h"



// not sure what this does?
using namespace std;
template<class T, void(T::*mem_fn)()>
  void* thunk2(void* p)
{
  (static_cast<T*>(p)->*mem_fn)();
  return 0;
}

class SkybotixInterface {
 protected:
  double X;
  double Y;
  double Z;

  double Roll;
  double Pitch;
  double Yaw;

  FrameData CurFrame;
  int NextFrameTime;

  pthread_t mySubThread;
  // pthread_mutex_t velocity_mutex;
  pthread_mutex_t curl_mutex;

  char * host;
  CURL* general_curl;
  CURL* mutexed_curl;

#ifndef NO_OPENCV
  IplImage* m_pLastImage;
#endif

  char* errorBuffer;
  CURLcode libcurl_sendcommand(CURL* curl, char* urlstr, string& buffer);
  void libcurl_grabframe( char* urlstr);
  void libcurl_getstate(char* urlstr);
  void libcurl_sendcommand_noresp(char * urlstr);

  void curl_setup(CURL*& curl);
  void sockerror(const char *msg);

 public:
  SkybotixInterface(const char* ip_addr);
  ~SkybotixInterface(void);
   void GetImage(void);
  void PeriodicUpdate();
  FrameData GetCurFrame(void);
};
